//////////////////////////////////////////////////////////////////////
//
//  SDIDEMO.PRG
//
//  Copyright:
//      Alaska Software, (c) 1997-2016. All rights reserved.
//
//  Contents:
//      Main routine and AppSys() for a SDI application
//
//////////////////////////////////////////////////////////////////////

#include "common.ch"
#include "Gra.ch"
#include "Xbp.ch"
#include "AppEvent.ch"
#include "Sdidemo.ch"

#pragma Library( "Xppui2.lib" )

/*
 * Main procedure and event loop
 */
PROCEDURE Main
LOCAL nEvent   := 0
LOCAL mp1      := nil
LOCAL mp2      := nil
LOCAL oXbp     := nil

SetAppWindow():close := {|mp1,mp2,obj| AppQuit() }

Do While TRUE
   nEvent := AppEvent( @mp1, @mp2, @oXbp )
   oXbp:handleEvent( nEvent, mp1, mp2 )
Enddo
Return

/*
 * Example for AppSys() in an SDI application
 * The function is executed prior to Main()
 */
PROCEDURE AppSys
   LOCAL oDlg, aPos[2], aSize, nHeight:=660, nWidth := 1024

   // Get size of desktop window
   // to center the application window
   aSize    := SetAppWindow():currentSize()
   aPos[1]  := Int( (aSize[1]-nWidth ) / 2 )
   aPos[2]  := Int( (aSize[2]-nHeight) / 2 )

   // Create application window
   oDlg := XbpDialog():new()
   oDlg:title    := "Toys & Fun Inc. [Xbase++ - SDI Demo]"
   oDlg:border   := XBPDLG_DLGBORDER
   oDlg:taskList := .T.
   oDlg:maxButton:= .F.
   oDlg:create( ,, aPos, {nWidth, nHeight},, .F. )

   // Select font
   oDlg:drawingArea:SetFontCompoundName( "8.Helv" )

   // Create menu system (UDF)
   MenuCreate( oDlg:menuBar() )

  // Provide online help via UDF
   // Display application window and set focus to it
   oDlg:show()
   SetAppWindow( oDlg )
   SetAppFocus ( oDlg )

RETURN
/*
 * Routine to terminate the programm
 */
PROCEDURE AppQuit()
   LOCAL nButton, oXbp := SetAppFocus()

   nButton := ConfirmBox( , ;
                 "Do you really want to quit ?", ;
                 "Quit", ;
                  XBPMB_YESNO , ;
                  XBPMB_QUESTION+XBPMB_APPMODAL+XBPMB_MOVEABLE )

   IF nButton == XBPMB_RET_YES
      QUIT
   ENDIF

   SetAppFocus( oXbp )
RETURN




